
function init() {
  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

  try {
    var checkboxes = ["percentDisplay", "speedDisplay", "sizeDisplay", "timeDisplay",
    				  "removeOnOpen", "removeOnShow", "askOnDelete", "clearOnClose", "imageRemove",
    				  "downloadRemove", "keepHistory", "trimHistory", "shouldScan", "supressAlert",
    				  "launchOnClose"]; //, "queEnable"
    for (var i = 0; i < checkboxes.length; ++i) {
      var checkbox = document.getElementById(checkboxes[i]);
      checkbox.checked = pref.getBoolPref(checkbox.getAttribute("prefstring"));
    }

    var INTtextboxes = ["imageRmSec", "downloadRmSec", "trimNum"]; //, "queNum"
    for (var i = 0; i < INTtextboxes.length; ++i) {
    	var textbox = document.getElementById(INTtextboxes[i]);
    	var prefstring = textbox.getAttribute("prefstring");
    	textbox.value = pref.getIntPref(prefstring);
    }
    var STRtextboxes = ["exclude", "AVLoc", "ArgsBox"];
    for (var i = 0; i < STRtextboxes.length; ++i) {
    	var textbox = document.getElementById(STRtextboxes[i]);
    	var prefstring = textbox.getAttribute("prefstring");
    	textbox.value = pref.getCharPref(prefstring);
    }


  }
  catch (e) {
  }
  KHistCheck();
  VDispCheck();
  //QueCheck();
}

function saveSettings() {

  var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

  var checkboxes = ["percentDisplay", "speedDisplay", "sizeDisplay", "timeDisplay",
  					"removeOnOpen", "removeOnShow", "askOnDelete", "clearOnClose", "imageRemove",
  					"downloadRemove", "keepHistory", "trimHistory", "shouldScan", "supressAlert",
  					"launchOnClose"]; //, "queEnable"

  var db_stringsPref = document.getElementById("prefdownbarbundle");

  // only let the user select 2 or less display items
  var count = 0;
  for (var j = 0; j < 4; ++j) {
  	var checkbox = document.getElementById(checkboxes[j]);
  	if (checkbox.checked) ++count;
  }
  if (count > 2) {
  	var db_selectAlert = db_stringsPref.getString("selectTwo");
  	alert(db_selectAlert);
  	return false;
  }

  for (var i = 0; i < checkboxes.length; ++i) {
    var checkbox = document.getElementById(checkboxes[i]);
    pref.setBoolPref(checkbox.getAttribute("prefstring"), checkbox.checked);
  }

  var INTtextboxes = ["imageRmSec", "downloadRmSec", "trimNum"]; //, "queNum"
  for (var i = 0; i < INTtextboxes.length; ++i) {
  	var textbox = document.getElementById(INTtextboxes[i]);
  	pref.setIntPref(textbox.getAttribute("prefstring"), textbox.value);
  }

  var STRtextboxes = ["exclude", "AVLoc", "ArgsBox"];
  for (var i = 0; i < STRtextboxes.length; ++i) {
  	var textbox = document.getElementById(STRtextboxes[i]);
  	pref.setCharPref(textbox.getAttribute("prefstring"), textbox.value);
  }


  // Now get a reference to the main window and reset the new display
  try {
  	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
  	var wrecent = wm.getMostRecentWindow("navigator:browser");
  	wrecent.readPrefs();
  	wrecent.setAllDisplayItems();
  }
  catch (e){}

  return true;
}

function KHistCheck() {

	if(document.getElementById("keepHistory").checked) {
		document.getElementById("trimHistory").disabled = false;
		document.getElementById("trimNum").disabled = false;
		document.getElementById("itemsDes").disabled = false;
	}
	else {
		document.getElementById("trimHistory").disabled = true;
		document.getElementById("trimNum").disabled = true;
		document.getElementById("itemsDes").disabled = true;
	}
}

function confirmAVenable() {

	if(document.getElementById("shouldScan").checked) {
		var db_stringsPref = document.getElementById("prefdownbarbundle");
		var db_enableTxt = db_stringsPref.getString("enableAV");
		var enableConfirm = confirm(db_enableTxt);
		if (!enableConfirm){
			document.getElementById("shouldScan").checked = false;
		}
	}
	VDispCheck();
}

function VDispCheck() {

	if(document.getElementById("shouldScan").checked) {
		document.getElementById("excludeLabel").disabled = false;
		document.getElementById("exclude").disabled = false;
		document.getElementById("AVLocLabel").disabled = false;
		document.getElementById("AVLoc").disabled = false;
		document.getElementById("filePicker").disabled = false;
		document.getElementById("ArgsLabel").disabled = false;
		document.getElementById("ArgsBox").disabled = false;
	}
	else {
		document.getElementById("excludeLabel").disabled = true;
		document.getElementById("exclude").disabled = true;
		document.getElementById("AVLocLabel").disabled = true;
		document.getElementById("AVLoc").disabled = true;
		document.getElementById("filePicker").disabled = true;
		document.getElementById("ArgsLabel").disabled = true;
		document.getElementById("ArgsBox").disabled = true;
	}

}

function QueCheck() {
	if(document.getElementById("queEnable").checked) {
		document.getElementById("queDownlbl").disabled = false;
		document.getElementById("queNum").disabled = false;
		document.getElementById("queFileslbl").disabled = false;
	}
	else {
		document.getElementById("queDownlbl").disabled = true;
		document.getElementById("queNum").disabled = true;
		document.getElementById("queFileslbl").disabled = true;

	}

}

function selectFolder() {

	const nsIFilePicker = Components.interfaces.nsIFilePicker;
	const nsILocalFile = Components.interfaces.nsILocalFile;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
	                 .createInstance(nsIFilePicker);

	fp.init(window, "Select Anti-Virus Executable:", nsIFilePicker.modeOpen);
	fp.appendFilters(nsIFilePicker.filterAll);
	var ret = fp.show();

	var fileField = document.getElementById("AVLoc");
	if (ret == nsIFilePicker.returnOK) {
		var localFile = fp.file.QueryInterface(nsILocalFile);
		var viewable = fp.file.path;
		fileField.value = viewable;
	}
	else if (ret == nsIFilePicker.returnCancel) {

	}
}

/*function setColorWell (aPicker) {

	var colorRef = aPicker.nextSibling;
	colorRef.setAttribute("value", aPicker.color);
}*/